Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");
const Cc = Components.classes;
const Ci = Components.interfaces;

function BMBBookmarksAboutHandler()
{
}

BMBBookmarksAboutHandler.prototype = {
	classDescription: "BMB about: handler that displays bookmarks",
	classID: Components.ID("{66186e30-75d7-4ba0-b3bc-c9b1a7738867}"),
	contractID: "@mozilla.org/network/protocol/about;1?what=bookmarks",
	QueryInterface: XPCOMUtils.generateQI([Ci.nsIAboutModule]),
	
	newChannel: function(aURI)
	{
		var ios = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService);
		var channel = ios.newChannel("chrome://bmb-ext/content/bookmarksTab.xul", null, null);
		
		channel.originalURI = aURI;
		
		return channel;
	},
	getURIFlags: function(aURI)
	{
		return (Ci.nsIAboutModule.ALLOW_SCRIPT | Ci.nsIAboutModule.URI_SAFE_FOR_UNTRUSTED_CONTENT);
	}
};

function BMBHistoryAboutHandler()
{
}

BMBHistoryAboutHandler.prototype = {
	classDescription: "BMB about: handler that displays the history",
	classID: Components.ID("{1cecda43-52b4-4877-b467-b0416a33979d}"),
	contractID: "@mozilla.org/network/protocol/about;1?what=history",
	QueryInterface: XPCOMUtils.generateQI([Ci.nsIAboutModule]),
	
	newChannel: function(aURI)
	{
		var ios = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService);
		var channel = ios.newChannel("chrome://bmb-ext/content/historyTab.xul", null, null);
		
		channel.originalURI = aURI;
		
		return channel;
	},
	getURIFlags: function(aURI)
	{
		return (Ci.nsIAboutModule.ALLOW_SCRIPT | Ci.nsIAboutModule.URI_SAFE_FOR_UNTRUSTED_CONTENT);
	}
};

function NSGetModule(aCompMgr, aFileSpec)
{
	return XPCOMUtils.generateModule([BMBBookmarksAboutHandler, BMBHistoryAboutHandler]);
}
